/*
	limpador do luca0N! 3
	Copyright (C) 2020  luca0N!

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.

	Contact me by e-mail via <mailto:luca0n@protonmail.com>
*/
#include "about.h"
#include "str.h"
#include "colors.h"

#include <windows.h>
#include <stdio.h>
#include <string.h>

int printLicense(int full){
	if (full == 0) {
		printf("%s\n", LICENSE_0);
		printf("%s\n", LICENSE_1);
		printf("%s\n", LICENSE_2);
		printf("%s\n", LICENSE_3);
		return 0;
	} else {
		FILE* flic = fopen("./LICENSE", "r");
		if (flic == NULL){
			printf("%s\n", STR_ERROR_LIC);
			return -1;
		}
		char c;
		while ((c = fgetc(flic)) != EOF) {
			printf("%c", c);
		}
	}
}

void getAdditionalDirs(){
	printf("%sRecolhendo pastas adicionais...\n", ANSI_COLOR_CYAN);
	int dirs;
	dirs = GetPrivateProfileInt("Pastas", "Pastas", 3, ".\\cfg\\pastas.ini");
	printf("%s %d\n", STR_DIR_COUNT, dirs);
	fflush(stdout);
	for(unsigned short x = 0; x < dirs; x++){
		char dirKey[7] = "Pasta"; // PastaX...
		//strcpy(dirKey, "Pasta");
		char* intPtr = (x + 1) + '0';
		strcat(dirKey, &intPtr);
		_TCHAR currentPath[128];
		GetPrivateProfileString("Pastas", dirKey, "null", currentPath,
			sizeof(currentPath) / sizeof(currentPath[0]), ".\\cfg\\pastas.ini");
		printf("%s [%s] %s\n", STR_FOUND_DIR, dirKey, currentPath);
	}
}

void cleanLoadedDirs(){
	printf("%s%s\n", ANSI_COLOR_CYAN, STR_CLEANING_DIRS);

	// TODO: Limpar pastas.
}

int main(void){
	printLicense(0);

	printf("--------------------\n%s %d, %s\n", PROGRAM_NAME, PROGRAM_SEASON, PROGRAM_VERSION);
	printf("%s\n--------------------\n\n", PROGRAM_COPYRIGHT);

	printf("%s%s\n", ANSI_COLOR_YELLOW, STR_USE_WARNING);
	char in;
	printf(ANSI_COLOR_RESET);
	fflush(stdout);

	scanf("%c", &in);

	if (in == 'w' || in == 'c')
		if (printLicense(1) != 0)
			return 0;

	if (in != 's' && in != 'S' && in != 'y' && in != 'Y')
		return 0;
	getAdditionalDirs();
	cleanLoadedDirs();
	printf("%s", ANSI_COLOR_RESET);
	return 0;
}